Attribute VB_Name = "OGLModule"
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'  Ce module contient des codes VB6 OpenGL pour l'initialisation, la texture , la lumire              '
'                   CopyRight  2004 cuq@free.fr                                                       '
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Option Explicit

'Declarations...

Global hglRC1 As Long, hglRC2 As Long 'Rendering context handles
Global hDC1 As Long, hDC2 As Long     'HDC's of viewports
Global QObj As Long                   'GLU Quadric Object

'Variables pour la lumire...
Dim Amb_Dif_Light(3) As Single '= { 0.5!, 0.5!, 0.5!, 1.0! } 'ambient n diffuse light
Dim SpecularLight(3) As Single '= { 1.0!, 1.0!, 1.0!, 1.0! } ' specular light
Dim Light1Pos!(3) 'la lumire qui claire la scne


Public Selected As Byte     'Identifie  objet qui est sous le pointeur de la souris

' Fonction d'initialisation OpenGL
Function InitGL() As Boolean
Dim Pfd As PIXELFORMATDESCRIPTOR
Dim Result As Long
  'Setup PDF n RC ...
  Pfd.nSize = Len(Pfd)
  Pfd.nVersion = 1
  Pfd.dwFlags = PFD_SUPPORT_OPENGL Or PFD_DRAW_TO_WINDOW Or PFD_DOUBLEBUFFER Or PFD_TYPE_RGBA
  Pfd.iPixelType = PFD_TYPE_RGBA
  Pfd.cColorBits = 32
  Pfd.cDepthBits = 16
 
 
  Result = ChoosePixelFormat(hDC1, Pfd)
  If Result = 0 Then
      MsgBox "OpenGL Initialization Failed!", vbCritical
      InitGL = False
      Exit Function
  End If
  SetPixelFormat hDC1, Result, Pfd
  hglRC1 = wglCreateContext(hDC1)
  
  'Init variable OpenGL ...
  Amb_Dif_Light(0) = 0.5!
  Amb_Dif_Light(1) = 0.5!
  Amb_Dif_Light(2) = 0.5!
  Amb_Dif_Light(3) = 1!
  
  SpecularLight(0) = 1!
  SpecularLight(1) = 1!
  SpecularLight(2) = 1!
  SpecularLight(3) = 1!
  
  
  'lumire 1
  Light1Pos(0) = 0!
  Light1Pos(1) = 0!
  Light1Pos(2) = -20!
  Light1Pos(3) = 1!
  


  
  'ViewPort 1 Specific inits...
  wglMakeCurrent hDC1, hglRC1
  glClearColor 0, 0, 0, 0  ' Couleur du fond de la scene OpenGL
  glShadeModel (GL_SMOOTH) 'Lissage des ombrages
  glEnable GL_CULL_FACE    'Pas de calcul de l'intrieur des faces
  glFrontFace GL_CCW
  glEnable GL_DEPTH_TEST
  glClearDepth 1
  glDepthFunc cfLEqual
  glBlendFunc GL_SRC_ALPHA, GL_DST_ALPHA
  glEnable GL_COLOR_MATERIAL
  
  glEnable GL_LIGHTING    'Active la lumire
  

  'Setup Light1, cette lumire claire la scne
  glLightfv GL_LIGHT1, GL_AMBIENT, Amb_Dif_Light(0)
  glLightfv GL_LIGHT1, GL_DIFFUSE, Amb_Dif_Light(0)
  glLightfv GL_LIGHT1, GL_SPECULAR, SpecularLight(0)
  glLightfv GL_LIGHT1, GL_POSITION, Light1Pos(0)    'Place la lumire devant le cube
  
  'Materials r Specular...
  glMaterialfv GL_FRONT, GL_SPECULAR, SpecularLight(0)
  glMaterialf GL_FRONT, GL_SHININESS, 1!
  
  'Active lumire 1
  glEnable GL_LIGHT1

  InitGL = True
End Function

' si le triangle slectionn est gal au triangle courant alors change de couleur
' tiangle=rouge
' triangle slectionn = bleu
' si pas de slection = vert
Sub Hight_Light(NbTriangle As Byte, Selection As Byte)
' si Selection
If NbTriangle = Selection Then
    glColor3f 0, 0, 1  ' bleu
Else
    If Selection = 0 Then
        glColor3f 0, 1, 0  'vert
    Else
        glColor3f 1#, 0#, 0 'rouge
    End If
    
End If


End Sub
' Affiche un cube en opengl avec des triangles (16 triangles)
' Lg reprsente la demi-longueur d'artes
Sub Affiche_Cube(Lg As Double, ModeOgl As glBeginModeConstants)

glPushMatrix

    Call Hight_Light(1, Selected)
    glPushName 1  'Triangle 1
    glBegin ModeOgl
      glNormal3f 0#, 1#, 0#
      glVertex3f -Lg, Lg, Lg
      glVertex3f Lg, Lg, Lg
      glVertex3f -Lg, Lg, -Lg
   glEnd
   glPopName
   
   Call Hight_Light(2, Selected)
   glPushName 2  'Triangle 2
    glBegin ModeOgl
      glNormal3f 0#, 0#, 1#
      glVertex3f Lg, -Lg, Lg
      glVertex3f Lg, Lg, Lg
      glVertex3f -Lg, Lg, Lg
    glEnd
   glPopName
   
   Call Hight_Light(3, Selected)
   glPushName 3  'Triangle 3
    glBegin ModeOgl
      glNormal3f 0#, 1#, 0#
      glVertex3f Lg, Lg, -Lg
      glVertex3f -Lg, Lg, -Lg
      glVertex3f Lg, Lg, Lg
    glEnd
   glPopName
   
   Call Hight_Light(4, Selected)
   glPushName 4  'Triangle 4
    glBegin ModeOgl
      glNormal3f -1#, 0#, 0#
      glVertex3f -Lg, Lg, -Lg
      glVertex3f -Lg, -Lg, -Lg
      glVertex3f -Lg, Lg, Lg
    glEnd
   glPopName
   
   Call Hight_Light(5, Selected)
   glPushName 5  'Triangle 5
    glBegin ModeOgl
      glNormal3f 1#, 0#, 0#
      glVertex3f Lg, Lg, -Lg
      glVertex3f Lg, Lg, Lg
      glVertex3f Lg, -Lg, Lg
   glEnd
   glPopName
   
   Call Hight_Light(6, Selected)
   glPushName 6  'Triangle 6
    glBegin ModeOgl
      glNormal3f 0#, 0#, 1#
      glVertex3f Lg, -Lg, Lg
      glVertex3f -Lg, Lg, Lg
      glVertex3f -Lg, -Lg, Lg
    glEnd
   glPopName
   
   Call Hight_Light(7, Selected)
   glPushName 7  'Triangle 7
    glBegin ModeOgl
      glNormal3f 0#, 0#, -1#
      glVertex3f -Lg, Lg, -Lg
      glVertex3f Lg, Lg, -Lg
      glVertex3f Lg, -Lg, -Lg
   glEnd
   glPopName
   
   Call Hight_Light(8, Selected)
   glPushName 8  'Triangle 8
   glBegin ModeOgl
      glNormal3f 0#, 0#, -1#
      glVertex3f -Lg, Lg, -Lg
      glVertex3f Lg, -Lg, -Lg
      glVertex3f -Lg, -Lg, -Lg
   glEnd
   glPopName
   
   Call Hight_Light(9, Selected)
   glPushName 9  'Triangle 9
   glBegin ModeOgl
      glNormal3f -1#, 0#, 0#
      glVertex3f -Lg, -Lg, Lg
      glVertex3f -Lg, Lg, Lg
      glVertex3f -Lg, -Lg, -Lg
   glEnd
   glPopName
   
   Call Hight_Light(10, Selected)
   glPushName 10  'Triangle 10
   glBegin ModeOgl
      glNormal3f 1#, 0#, 0#
      glVertex3f Lg, -Lg, -Lg
      glVertex3f Lg, Lg, -Lg
      glVertex3f Lg, -Lg, Lg
   glEnd
   glPopName
   
   Call Hight_Light(11, Selected)
   glPushName 11  'Triangle 11
   glBegin ModeOgl
      glNormal3f 0#, -1#, 0#
      glVertex3f Lg, -Lg, -Lg
      glVertex3f Lg, -Lg, Lg
      glVertex3f -Lg, -Lg, Lg
   glEnd
   glPopName
   
   Call Hight_Light(12, Selected)
   glPushName 12  'Triangle 12
   glBegin ModeOgl
      glNormal3f 0, -1#, 0#
      glVertex3f Lg, -Lg, -Lg
      glVertex3f -Lg, -Lg, Lg
      glVertex3f -Lg, -Lg, -Lg
   glEnd
   glPopName
   
glPopMatrix
End Sub
